#include <stdio.h>
#include <sys/types.h>
#include <math.h>

#include "../include/os.h"

#ifdef __MSW__
# include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>

#include "gw.h"

#include "sarreality.h"
#include "obj.h"
#include "sfm.h"
#include "sar.h"
#include "sardrawpm.h"


void SARDrawPremodeled(
        gw_display_struct *display,
        sar_scene_struct *scene,
        sar_object_struct *obj_ptr,
        sar_object_premodeled_struct *obj_premodeled_ptr,
        sar_position_struct *camera_pos, sar_direction_struct *camera_dir,
	double camera_dist, Boolean draw_for_gcc
);


#define MAX(a,b)        (((a) > (b)) ? (a) : (b))
#define MIN(a,b)        (((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)     (MIN(MAX((a),(l)),(h)))


/*
 *	Front end to drawing premodeled objects, called by SARDraw().
 */
void SARDrawPremodeled(
        gw_display_struct *display,
        sar_scene_struct *scene,
        sar_object_struct *obj_ptr,
        sar_object_premodeled_struct *obj_premodeled_ptr,
        sar_position_struct *camera_pos, sar_direction_struct *camera_dir,
	double camera_dist, Boolean draw_for_gcc
)
{
        if((obj_ptr == NULL) || (obj_premodeled_ptr == NULL))
            return;

        switch(obj_premodeled_ptr->type)
        {
          case SAR_OBJ_PREMODELED_BUILDING:
            SARDrawPremodeledBuilding(
                display, scene, obj_ptr, obj_premodeled_ptr,
                draw_for_gcc
            );
            break;
          case SAR_OBJ_PREMODELED_CONTROL_TOWER:
            SARDrawPremodeledControlTower(
                display, scene, obj_ptr, obj_premodeled_ptr,
                draw_for_gcc
            );
            break;
          case SAR_OBJ_PREMODELED_POWER_TRANSMISSION_TOWER:
            SARDrawPremodeledPowerTransmissionTower(
                display, scene, obj_ptr, obj_premodeled_ptr,
                camera_dist,
                draw_for_gcc
            );
            break;
	  case SAR_OBJ_PREMODELED_TOWER:
            SARDrawPremodeledTower(
                display, scene, obj_ptr, obj_premodeled_ptr,
                camera_dist,
                draw_for_gcc
            );
	    break;
          case SAR_OBJ_PREMODELED_RADIO_TOWER:
            SARDrawPremodeledRadioTower(
                display, scene, obj_ptr, obj_premodeled_ptr,
                camera_dist,
                draw_for_gcc
            );
            break;

        }



}

