/*
                             SAR Sound Utilities

	See sound.c for low-level to sound output library functions.

 */

#ifndef SARSOUND_H
#define SARSOUND_H

#include "sound.h"
#include "obj.h"


extern void SARSoundEngineVolumeMute(
        snd_recorder_struct *recorder,
        snd_play_struct *inside_snd_play,
        snd_play_struct *outside_snd_play
);
extern void SARSoundAdjustEngineVolume(
        snd_recorder_struct *recorder,
        sar_sound_source_struct **list, int total,
        snd_play_struct *inside_snd_play,
        int inside_sndsrc_num,
        snd_play_struct *outside_snd_play,
        int outside_sndsrc_num,
	int ear_in_cockpit,
	int engine_state,			/* One of SAR_ENGINE_STATE_*. */
	double throttle,			/* Throttle coeff 0.0 to 1.0. */
	double distance_to_camera		/* In meters. */
);
extern void SARSoundStallUpdate(
        snd_recorder_struct *recorder,
        sar_sound_source_struct **list, int total,
	void **stall_snd_play,
        int stall_sndsrc_num,
        int ear_in_cockpit,
        int flight_model, int is_landed,
        double speed, double speed_stall
);
extern void SARSoundOverSpeedUpdate(
        snd_recorder_struct *recorder,
        sar_sound_source_struct **list, int total,
        void **overspeed_snd_play,
        int overspeed_sndsrc_num,
        int ear_in_cockpit, int is_overspeed
);


#endif	/* SARSOUND_H */
